<template>
  <div id="parentone">
    <div id="addTime" v-if="this.show === false">
      <h1>Add time for a user</h1>
      <b-container fluid id="container">
        <div>
          <label for="input-default">Username:</label><br />
          <b-form-select v-model="user" :options="mappedInfos"></b-form-select>
        </div>
        <div>
          <label for="input-default">Start time:</label>
          <datetime type="datetime" v-model="start"></datetime>
        </div>
        <div>
          <label for="input-default">End time:</label>
          <datetime type="datetime" v-model="end"></datetime>
        </div>
      </b-container>
      <b-button variant="success" @click="addWorks()">
        <b-icon icon="calendar-plus" aria-hidden="true"></b-icon>
        Add workingtimes
      </b-button>
    </div>
    <div id="editTime" v-if="this.show === false">
      <h1>Edit time for a user</h1>
      <b-container fluid id="container">
        <div>
          <label for="input-default">Username:</label><br />
          <b-form-select v-model="user2" :options="mappedInfos"></b-form-select>
        </div>
      </b-container>
      <b-button style="margin-top: 10px" variant="primary" @click="editWorks()">
            <font-awesome-icon icon="edit" />        Edit workingtimes
      </b-button>
    </div>
    <div id="editTime" v-if="this.show === true">
      <h1>Edit time for a user</h1>
      <b-button variant="danger" @click="unshow()" id="unshow"><font-awesome-icon icon="times-circle"/>
        </b-button>
      <b-container fluid id="container">
          <Workingtime :user2="this.user2"></Workingtime>
      </b-container>
    </div>
  </div>
</template>

<script>
import axios from "axios";
import Vue from "vue";
import { BButton, BFormSelect, BFormInput, BFormRadio } from "bootstrap-vue";
import "bootstrap/dist/css/bootstrap.css";
import "bootstrap-vue/dist/bootstrap-vue.css";
Vue.component("b-form-select", BFormSelect);
Vue.component("b-button", BButton);
Vue.component("b-form-input", BFormInput);
Vue.component("b-form-radio", BFormRadio);
Vue.component("Workingtime", workingtime);
import config from "@/Utils/config.json";
import moment from "moment";
import EventBus from "../EventBus";
import workingtime from "../Workingtime"
import { FontAwesomeIcon } from "@fortawesome/vue-fontawesome";
import { faTimesCircle } from "@fortawesome/free-solid-svg-icons";
import { library } from "@fortawesome/fontawesome-svg-core";
library.add(faTimesCircle);
Vue.component("font-awesome-icon", FontAwesomeIcon);

export default {
  name: "Managertime",
  props: {
    //   user2: String
  },
  data() {
    return {
      user: "",
      start: "",
      end: "",
      mappedInfos: [],
      show: false,
      user2: ""
    };
  },
  methods: {
    addWorks() {
      if (!this.user && !this.start && !this.end) return;
      const user = this.user;
      axios.post(
        `${config.config.res_endpoint}api/workingtimes/${user}`,
        {
          workingtime: {
            start: "" + moment.utc(this.start).local().format(),
            end: "" + moment.utc(this.end).local().format(),
          },
        },
        {
          headers: {
            Authorization: "Bearer " + localStorage.getItem("accesToken"),
          },
        }
      );
      this.start = "";
      this.end = "";
      this.user = "";
      EventBus.$emit("ADD_WORKS", { blabla: "addwork" });
    },
    editWorks () {
        // this.user2= "";
        if (this.show === false) {
            this.show = true
        }
        else if (this.show === true) {
            this.show = false
        }
    },
    unshow () {
        this.show = false
    }
  },
  mounted() {
    axios
      .get(`${config.config.res_endpoint}api/users`, {
        headers: {
          Authorization: "Bearer " + localStorage.getItem("accesToken"),
        },
      })
      .then((response) => {
        this.info = response.data.data;
        this.mappedInfos = this.info.map((info) => {
          return { value: info.id, text: info.username };
        });
      });
  },
};
</script>

<style scoped>
#addTime {
  width: 40%;
  /* margin-left: 30%; */
  border-color: black;
  border-width: 5px;
  border-style: solid;
  margin-top: 30px;
  /* background: lightblue; */
  /* display: flex; */
  /* flex-direction: column; */
  /* justify-content: space-around; */
}

#addTime h1 {
  text-align: center;
}

#addTime select {
  width: 185px;
}

#addTime button {
  margin-top: 10px;
  width: 40%;
  align-content: flex-end;
  margin-bottom: 20px;
}

#editTime {
    position: relative;
  width: 40%;
  /* margin-left: 30%; */
  border-color: black;
  border-width: 5px;
  border-style: solid;
  margin-top: 30px;
  /* background: lightblue; */
  /* display: flex; */
  /* flex-direction: column; */
  /* justify-content: space-around; */
}

#editTime h1 {
  text-align: center;
}

#editTime select {
  width: 185px;
}

#editTime button {
  /* margin-top: 10px; */
  /* width: 40%; */
  align-content: flex-end;
  margin-bottom: 20px;
}

#container {
  text-align: center;
}

#parentone {
    display: flex;
    flex-direction: row;
    justify-content: space-around;
    text-align: center;
}

#unshow {
    position: absolute;
    top: 10px;
    right: 10px;
    /* width: 20% */
}

#unshow button {
    width: 50px;
}
</style>